// $Id: AverageReader.java,v 1.4.4.2 2003/08/18 22:09:44 cssharp Exp $

/*									tab:4
 * "Copyright (c) 2000-2003 The Regents of the University  of California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Copyright (c) 2002-2003 Intel Corporation
 * All rights reserved.
 *
 * This file is distributed under the terms in the attached INTEL-LICENSE
 * file. If you do not find these files, copies can be found by writing to
 * Intel Research Berkeley, 2150 Shattuck Avenue, Suite 1300, Berkeley, CA,
 * 94704.  Attention:  Intel License Inquiry.
 */
//package net.tinyos.tinydb;

//import net.tinyos.util.ByteOps;

/**
 * Implements reader for AVERAGE aggregate
 *
 * @author Eugene Shvets
 * @version 1.0, October 23, 2002
 *
 * Changed 11.3.2002 to use objects for state.  SRM.
 */
 
 /*
* Modifications: 
*
* Copyright (c) 2004-2005, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   * Redistributions of source code must retain the above copyright notice,
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its
*     contributors may be used to endorse or promote products derived from
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
*/


/*

 * Modification author: Bingsheng He (saven@cs.ust.hk)
 
********************************************************************************/
class SketchAverageData{
	public int s_rLen;//2
	public int s_oneLen;//4
	public int s_zeroLen;
	public int []s_data;
	public int []s_bitmap;
	public int s_result;

	public int c_rLen;//2
	public int c_oneLen;//4
	public int c_zeroLen;
	public int []c_data;
	public int []c_bitmap;
	public int c_result;
	//public int raw;

	public SketchAverageData(byte[] rdata)
	{
		int i;
		s_data= new int[10];
		s_bitmap=new int[10];
		c_data= new int[10];
		c_bitmap=new int[10];

		s_rLen=rdata[1]&0x7f;
		s_oneLen=rdata[0]&0xff;
		s_zeroLen=rdata[2]&0xff;
		for(i=0;i<8;i++)
		{
			s_data[i]=rdata[i+3];
			s_data[i]=(s_data[i]+128+64+32)&0xff;
		}

		c_rLen=rdata[12]&0xff;
		c_oneLen=rdata[11]&0xff;
		c_zeroLen=rdata[13]&0xff;
		for(i=0;i<8;i++)
		{
			c_data[i]=rdata[i+14];
			c_data[i]=(c_data[i]+128+64)&0xff;
		}




	}
	public void uncompress()
	{
		int i=0;
		int j=0;
		int rl=0;
		int start=0;
		int curbit=0;
		for(i=0;i<10;i++)
		{
			s_bitmap[i]=0;
			c_bitmap[i]=0;
		}
		rl=s_oneLen;
		for(j=0;j<16;j++)
		{
			for(i=0;i<10;i++)
			{
				if(rl>0)
				{
					s_bitmap[i]=s_bitmap[i] | (0x01<<j);
					rl--;
				}
				else
					break;

			}
			if(rl==0)
				break;
		}
		start=s_oneLen;
		rl=s_rLen;

		for(i=0;i<s_rLen;i++)
		{
			curbit=s_data[i/8] & (0x01<<(7-i%8));
			if(curbit!=0)
			{
				curbit=curbit>>(7-i%8);
				s_bitmap[(start+i)%10]=s_bitmap[(start+i)%10] | (curbit<<((start+i)/10));
			}
		}

		//copying the count.........
		rl=0;
		start=0;
		curbit=0;
		rl=c_oneLen;
		for(j=0;j<16;j++)
		{
			for(i=0;i<10;i++)
			{
				if(rl>0)
				{
					c_bitmap[i]=c_bitmap[i] | (0x01<<j);
					rl--;
				}
				else
					break;

			}
			if(rl==0)
				break;
		}
		start=c_oneLen;
		rl=c_rLen;

		for(i=0;i<c_rLen;i++)
		{
			curbit=c_data[i/8] & (0x01<<(7-i%8));
			if(curbit!=0)
			{
				curbit=curbit>>(7-i%8);
				c_bitmap[(start+i)%10]=c_bitmap[(start+i)%10] | (curbit<<((start+i)/10));
			}
		}
	}

	void sumPCSA()
	{
		//variables for sum
		int R=0;
		int S=0;
		int tmpnmap=1;
		int i=0;
		int count;
		int tmp=0;
		for(i=0;i<10;i++)
		{
			R=0;
			//printf("(%x,",bitmap[i]);
			tmp=s_bitmap[i];
			while( ((tmp& 0x01)>0) && (R < 16))
			{
			tmp=tmp>>1;
			R=R+1;
			}
			S=S+R;
			//printf("%d)",R);
		}
		s_result=(int)((10.0*(Math.pow(2,((double)S/10.0))))/0.77351);

	}

	void sumCount()
	{
		//variables for sum
		int R=0;
		int S=0;
		int tmpnmap=1;
		int i=0;
		int count;
		int tmp=0;
		for(i=0;i<10;i++)
		{
			R=0;
			//printf("(%x,",bitmap[i]);
			tmp=c_bitmap[i];
			while( ((tmp& 0x01)>0) && (R < 16))
			{
			tmp=tmp>>1;
			R=R+1;
			}
			S=S+R;
			//printf("%d)",R);
		}
		c_result=(int)((10.0*(Math.pow(2,((double)S/10.0))))/0.77351);

	}
};

public class AverageReader{
    /**
	 * Reads data from the byte array from QueryResultMessage
	 */
    public void read(byte[] data) {
		myState = new AverageData();
		/*myState.sum = 9;
		myState.count = 3;
		int i;
		for(i=0;i<11;i++)
		System.out.print((data[i]&0xff)+",");
		System.out.println("");
		for(i=0;i<11;i++)
		System.out.print((data[i+11]&0xff)+",");*/
		sketch=new SketchAverageData(data);
		sketch.uncompress();
		sketch.sumPCSA();
		sketch.sumCount();
		System.out.println("S:rLen="+sketch.s_rLen+", oneLen="+sketch.s_oneLen+", zeroLen="+sketch.s_zeroLen);
		for(int i=0;i<8;i++)
		System.out.print(sketch.s_data[i]+"("+Integer.toHexString(sketch.s_data[i])+"),");
		System.out.println("bitmap:");
		for(int i=0;i<10;i++)
		System.out.print(sketch.s_bitmap[i]+"("+Integer.toHexString(sketch.s_bitmap[i])+"),");
		System.out.println("");

		System.out.println("C:rLen="+sketch.c_rLen+", oneLen="+sketch.c_oneLen+", zeroLen="+sketch.c_zeroLen);
		for(int i=0;i<8;i++)
		System.out.print(sketch.c_data[i]+"("+Integer.toHexString(sketch.c_data[i])+"),");
		System.out.println("bitmap:");
		for(int i=0;i<10;i++)
		System.out.print(sketch.c_bitmap[i]+"("+Integer.toHexString(sketch.c_bitmap[i])+"),");
		System.out.println("");
		System.out.println("----sum="+sketch.s_result+", ---count="+sketch.c_result);
		myState.sum=sketch.s_result;
		myState.count=sketch.c_result;
		finalizeValue();
    }

	/**
	 * Calculates final value of the aggregate.
	 */
	public void finalizeValue() {
		if (myState.count != 0) myState.value = myState.sum / myState.count;
		else
		myState.value = 640;

	}

	/**
	 * Returns string representation of the finalized value
	 */
	public String getValue() {
	    if (myState.count != 0) return Integer.toString((int)(myState.sum / 4));
	    else return "";
	}


	AverageData myState;
	SketchAverageData sketch;

}

class AverageData  {
    int sum = 0;
    int count = 0;
	int value = 0;
}
