// $Id: IntReader.java,v 1.6.4.2 2003/08/18 22:09:44 cssharp Exp $

/*									tab:4
 * "Copyright (c) 2000-2003 The Regents of the University  of California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Copyright (c) 2002-2003 Intel Corporation
 * All rights reserved.
 *
 * This file is distributed under the terms in the attached INTEL-LICENSE
 * file. If you do not find these files, copies can be found by writing to
 * Intel Research Berkeley, 2150 Shattuck Avenue, Suite 1300, Berkeley, CA,
 * 94704.  Attention:  Intel License Inquiry.
 */


/**
 * Implements reader for aggregates whose state is determined by just one
 * integer - such as MIN, MAX, SUM
 *
 * @author Eugene Shvets
 * @edit by saven (saven@cs.ust.hk)
 * @version 1.0, October 23, 2002
 *
 * Changed 11.3.2002 to use objects for state.  SRM.
 */
 
 /*
* Modifications: 
*
* Copyright (c) 2004-2005, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   * Redistributions of source code must retain the above copyright notice,
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its
*     contributors may be used to endorse or promote products derived from
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
*/


/*

 * Modification author: Bingsheng He (saven@cs.ust.hk)
 
********************************************************************************/
class SketchAlgebraicData{
	public int rLen;//2
	public int oneLen;//4
	public int zeroLen;
	public int []data;
	public int []bitmap;
	public int sresult;
	//public int raw;

	public SketchAlgebraicData(byte[] rdata)
	{
		data= new int[10];
		bitmap=new int[10];

		rLen=rdata[1]&0x7f;
		oneLen=rdata[0]&0xff;
		zeroLen=rdata[2]&0xff;
		for(int i=0;i<8;i++)
		{
			data[i]=rdata[i+3];
			data[i]=(data[i]+128)&0xff;
		}
		/*data[8]=rdata[11]&0xff;
		data[9]=rdata[12]&0xff;
		System.out.println("raw data:"+(data[8])+" and "+(data[9]));
		raw=ByteOps.makeInt((byte)(data[8]&0xff),(byte)(data[9]&0xff));*/

	}
	public void uncompress()
	{
		int i=0;
		int j=0;
		int rl=0;
		int start=0;
		int curbit=0;
		for(i=0;i<10;i++)
			bitmap[i]=0;
		rl=oneLen;
		for(j=0;j<16;j++)
		{
			for(i=0;i<10;i++)
			{
				if(rl>0)
				{
					bitmap[i]=bitmap[i] | (0x01<<j);
					rl--;
				}
				else
					break;

			}
			if(rl==0)
				break;
		}
		start=oneLen;
		rl=rLen;

		for(i=0;i<rLen;i++)
		{
			curbit=data[i/8] & (0x01<<(7-i%8));
			if(curbit!=0)
			{
				curbit=curbit>>(7-i%8);
				bitmap[(start+i)%10]=bitmap[(start+i)%10] | (curbit<<((start+i)/10));
			}
		}
	}

	void sumPCSA()
	{
		//variables for sum
		int R=0;
		int S=0;
		int tmpnmap=1;
		int i=0;
		int count;
		int tmp=0;
		for(i=0;i<10;i++)
		{
			R=0;
			//printf("(%x,",bitmap[i]);
			tmp=bitmap[i];
			while( ((tmp& 0x01)>0) && (R < 16))
			{
			tmp=tmp>>1;
			R=R+1;
			}
			S=S+R;
			//printf("%d)",R);
		}
		sresult=(int)((10.0*(Math.pow(2,((double)S/10.0))))/0.77351);

	}
};
public class IntReader {

    /**
	 * Reads data from the byte array from QueryResultMessage
	 */


    public void read(byte[] data) {
		/*myState = ByteOps.makeInt(data[0], data[1]);
		myState2= ByteOps.makeInt(data[2], data[3]);
		int myState3= ByteOps.makeInt(data[4], data[5]);
		//----------------------bsaven--------------------
		int value=myState & 0xffff;
		System.out.println("S= "+myState+"("+Integer.toHexString(myState)+"), "+myState2+"("+Integer.toHexString(myState2)+"), "+Integer.toHexString(myState3));
		int ii=0;
		while((value & 0x01)>0)
		{
			ii=ii+1;
			value=value >>1;
		}
		value=(int)((Math.pow(2,ii))/0.775351);
		System.out.println("approximte value:"+value);
		myState=value;*/
		sketch=new SketchAlgebraicData(data);
		sketch.uncompress();
		sketch.sumPCSA();
		System.out.println("rLen="+sketch.rLen+", oneLen="+sketch.oneLen+", zeroLen="+sketch.zeroLen);
		for(int i=0;i<8;i++)
		System.out.print(sketch.data[i]+"("+Integer.toHexString(sketch.data[i])+"),");
		System.out.println("bitmap:");
		for(int i=0;i<10;i++)
		System.out.print(sketch.bitmap[i]+"("+Integer.toHexString(sketch.bitmap[i])+"),");
		System.out.println("");
		//System.out.println("raw="+sketch.raw+", result="+sketch.sresult);
		myState=(int)((double)sketch.sresult*3.1);

		//----------------------esaven--------------------
    }

    /**
	 * Calculates final value of the aggregate.
	 */
    public void finalizeValue() {
		// dont need to do anything
    }

    /**
	 * Returns string representation of the finalized value
	 */
    public String getValue() {
		return Integer.toString(myState);
    }



	SketchAlgebraicData sketch;
	int myState;
}
