/********************************************************************************
* Copyright (c) 2004-2005, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   * Redistributions of source code must retain the above copyright notice,
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its
*     contributors may be used to endorse or promote products derived from
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
* Author: Hejun Wu (vmnet@ust.hk).
********************************************************************************/


#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>

#define MAXIMUMAL_EXPS_NUM 100
char  g_tempMode[10]={0};
char * MapToStrMode(int iMode) 
{ 
	char *tempName=g_tempMode;
	if(iMode/100==1)
			sprintf(tempName," %s","I");
			else 
			sprintf(tempName," %s","C");
			tempName+=2;
			switch(iMode%100/10)
			{
			case 1: 
				sprintf(tempName,"%s","P");
				tempName++; 
				break;
			case 2:
			case 8:
				sprintf(tempName,"%s","I");
				tempName++;
				break;
			case 4:
				sprintf(tempName,"%s","A");
				tempName++;
				break;
			default:
				sprintf(tempName,"%s","P");
				tempName++;
				break;
			}

			switch(iMode%10)
			{
			case 0:
				sprintf(tempName,"%s","P");
				tempName++;
				break;

			case 1:
				sprintf(tempName,"%s","P");
				tempName++;
				break;
			case 2:
				sprintf(tempName,"%s","I");
				tempName++;
				break;
			case 4:
				sprintf(tempName,"%s","R");
				tempName++;
				break;
			case 8:
				sprintf(tempName,"%s","T");
				tempName++;
		  		break;
			default:
				sprintf(tempName,"%s","P");
				tempName++;
				break;
			}
			return g_tempMode;
}

typedef struct tagStatus
{
	unsigned short mode;
	struct tagStatus * prevPtr;
	struct tagStatus * nextPtr;
}STAUS_LINK;
#define TOTAL_TYPE_RECLOGS 1;
void main_task(char* powerStaFileName, int nRecCounts, int nEpochs,int staFh)
{
    int fh;
	unsigned char *readBuffer;
	char tempName[100]={0};
	int j=0;
	int filelen;
   
	fh = _open(powerStaFileName,_O_RDWR|_O_BINARY, _S_IREAD); 
	if(fh<0)
	{
		fprintf(stderr,"No this file, try others... %d \n", nRecCounts);
		return;
	}

	filelen=_filelength( fh );
	readBuffer=malloc(filelen);
	_read( fh, readBuffer, filelen);
	close(fh);
	j=0; 
	if(j<filelen)
	{
		char *tempPtr;
		char tempEpochStr[10]={0};
		while(readBuffer[j]!=9) j++;
		while(!(readBuffer[j]>='0'&&readBuffer[j]<='9')&&j<filelen)
			j++;
		tempPtr=readBuffer +j;
		while(((readBuffer[j]>='0'&&readBuffer[j]<='9')||readBuffer[j]=='.')&&j<filelen)		
			j++;
		if(j<filelen)
		readBuffer[j]=0;
		else 
			exit(1);
		//epoch number
		sprintf(tempEpochStr,"%d",nEpochs);
		_write( staFh,tempEpochStr,strlen(tempEpochStr)); 
		_write( staFh," \t", 2); 

		_write( staFh,tempPtr, strlen(tempPtr)); 
		_write( staFh," \t", 2); 

		

			while(!(readBuffer[j]>='0'&&readBuffer[j]<='9')&&j<filelen)
			j++;
		tempPtr=readBuffer +j;
		while(((readBuffer[j]>='0'&&readBuffer[j]<='9')||readBuffer[j]=='.')&&j<filelen)		
			j++;
		if(j<filelen)
		readBuffer[j]=0;
		else 
			exit(1);
		_write( staFh,tempPtr, strlen(tempPtr)); 
		_write( staFh," \n", 2); 

	}

}

int EXP_TIMES= 300;//default.
#define MAX_NODE_ID 100
void main()
{
	int i,j;
	char tempName[100]={0};
	char tempCmd[100]={0};
	int fh, tempFh;
	
	//fprintf(stderr,"Input your experiment times");
	//scanf("%d",&EXP_TIMES);
	for (i=0;i<MAX_NODE_ID;i++)
	{
		sprintf(tempName,"%d_%d_%s",i,0,"reclog_1.txt");//"%s%d_1.rec","power_log_",i);
		tempFh = _open(tempName,_O_RDWR|_O_BINARY, _S_IREAD); 
		if(tempFh>=0)
		{
			_close(tempFh);
			sprintf(tempName,"%d_staResult.txt",i);// 
			fh = _open(tempName,_O_RDWR| _O_CREAT|_O_BINARY|_O_TRUNC, _S_IREAD| _S_IWRITE );  
			if(fh<0)
			{
				fprintf(stderr,"Cannot open file for output \n");
				exit(-1);
			}
			for(j=0;j<EXP_TIMES;j++)
			{
#if 0
				sprintf(tempName,"exp%d/%s",i,"reclog_1.txt");//"%s%d_1.rec","power_log_",i);
#else
				sprintf(tempName,"%d_%d_%s",i,j,"reclog_1.txt");//"%s%d_1.rec","power_log_",i);
#endif
				main_task(tempName,i,j,fh);
			}
		}
	}
	_close(fh); 
}


